// ---------------------------------------------------------------------------
// 0: ABC_IMGSETTING_MODE_DIAL
// ---------------------------------------------------------------------------

// Basic zone
#define ABC_DIALMODE_AUTO			                0x0000      // Full Auto
// Creative zone
#define ABC_DIALMODE_PROGRAM			             0x0101      // Program AE
#define ABC_DIALMODE_Tv				                 0x0102      // Shutter priority AE
#define ABC_DIALMODE_Av				                 0x0103      // Aperture priority AE
#define ABC_DIALMODE_MANUAL			              0x0104      // Manual exposure
#define ABC_DIALMODE_A_DEP			               0x0105      // Automatic Depth-of-field AE
#define ABC_DIALMODE_BULB  		               0x0107      // BULB
// Image zone
#define ABC_DIALMODE_PORTRAIT               0x0800      // Portrait
#define ABC_DIALMODE_LANDSCAPE              0x0200      // Landscape
#define ABC_DIALMODE_CLOSEUP                0x0A00      // Close-up
#define ABC_DIALMODE_SPORTS                 0x0900      // Sports
#define ABC_DIALMODE_NIGHT_PORTRAIT         0x0500      // Night portrait
#define ABC_DIALMODE_NO_FLASH               0x0F00      // No flash

// ---------------------------------------------------------------------------
// 1: ABC_IMGSETTING_SHUTTER_SPEED (Camera set to 1/3-stop - C.Fn-6 = 0)
// ---------------------------------------------------------------------------
#define ABC_SHUTTERSPEED3_BULB              0x0004
#define ABC_SHUTTERSPEED3_30s               0x0010
#define ABC_SHUTTERSPEED3_25s               0x0013
#define ABC_SHUTTERSPEED3_20s               0x0015
#define ABC_SHUTTERSPEED3_15s               0x0018
#define ABC_SHUTTERSPEED3_13s               0x001b
#define ABC_SHUTTERSPEED3_10s               0x001d
#define ABC_SHUTTERSPEED3_8s                0x0020
#define ABC_SHUTTERSPEED3_6s                0x0023
#define ABC_SHUTTERSPEED3_5s                0x0025
#define ABC_SHUTTERSPEED3_4s                0x0028
#define ABC_SHUTTERSPEED3_3s2	              0x002b
#define ABC_SHUTTERSPEED3_2s5	              0x002d
#define ABC_SHUTTERSPEED3_2s	               0x0030
#define ABC_SHUTTERSPEED3_1s6	              0x0033
#define ABC_SHUTTERSPEED3_1s3	              0x0035
#define ABC_SHUTTERSPEED3_1s	               0x0038
#define ABC_SHUTTERSPEED3_0s8	              0x003b
#define ABC_SHUTTERSPEED3_0s6	              0x003d
#define ABC_SHUTTERSPEED3_0s5	              0x0040
#define ABC_SHUTTERSPEED3_0s4	              0x0043
#define ABC_SHUTTERSPEED3_0s3	              0x0045
#define ABC_SHUTTERSPEED3_1_4		             0x0048
#define ABC_SHUTTERSPEED3_1_5		             0x004b
#define ABC_SHUTTERSPEED3_1_6		             0x004d
#define ABC_SHUTTERSPEED3_1_8		             0x0050
#define ABC_SHUTTERSPEED3_1_10		            0x0053
#define ABC_SHUTTERSPEED3_1_13		            0x0055
#define ABC_SHUTTERSPEED3_1_15		            0x0058
#define ABC_SHUTTERSPEED3_1_20		            0x005b
#define ABC_SHUTTERSPEED3_1_25		            0x005d
#define ABC_SHUTTERSPEED3_1_30		            0x0060
#define ABC_SHUTTERSPEED3_1_40		            0x0063
#define ABC_SHUTTERSPEED3_1_50		            0x0065
#define ABC_SHUTTERSPEED3_1_60		            0x0068
#define ABC_SHUTTERSPEED3_1_80		            0x006b
#define ABC_SHUTTERSPEED3_1_100	            0x006d
#define ABC_SHUTTERSPEED3_1_125	            0x0070
#define ABC_SHUTTERSPEED3_1_160	            0x0073
#define ABC_SHUTTERSPEED3_1_200	            0x0075
#define ABC_SHUTTERSPEED3_1_250	            0x0078
#define ABC_SHUTTERSPEED3_1_320	            0x007b
#define ABC_SHUTTERSPEED3_1_400	            0x007d
#define ABC_SHUTTERSPEED3_1_500	            0x0080
#define ABC_SHUTTERSPEED3_1_640	            0x0083
#define ABC_SHUTTERSPEED3_1_800	            0x0085
#define ABC_SHUTTERSPEED3_1_1000	           0x0088
#define ABC_SHUTTERSPEED3_1_1250	           0x008b
#define ABC_SHUTTERSPEED3_1_1600	           0x008d
#define ABC_SHUTTERSPEED3_1_2000	           0x0090
#define ABC_SHUTTERSPEED3_1_2500	           0x0093
#define ABC_SHUTTERSPEED3_1_3200	           0x0095
#define ABC_SHUTTERSPEED3_1_4000	           0x0098
#define ABC_SHUTTERSPEED3_1_5000	           0x009b
#define ABC_SHUTTERSPEED3_1_6400	           0x009d
#define ABC_SHUTTERSPEED3_1_8000	           0x00a0
#define ABC_SHUTTERSPEED3_1_10000           0x00a3
#define ABC_SHUTTERSPEED3_1_12800           0x00a5
#define ABC_SHUTTERSPEED3_1_16000           0x00a8

// ---------------------------------------------------------------------------
// 1: ABC_IMGSETTING_SHUTTER_SPEED (Camera set to 1/2-stop - C.Fn-6 = 1)
// ---------------------------------------------------------------------------
#define ABC_SHUTTERSPEED2_BULB              0x0004
#define ABC_SHUTTERSPEED2_30s               0x0010
#define ABC_SHUTTERSPEED2_20s               0x0014
#define ABC_SHUTTERSPEED2_15s               0x0018
#define ABC_SHUTTERSPEED2_10s               0x001c
#define ABC_SHUTTERSPEED2_8s                0x0020
#define ABC_SHUTTERSPEED2_6s                0x0024
#define ABC_SHUTTERSPEED2_4s                0x0028
#define ABC_SHUTTERSPEED2_3s                0x002c
#define ABC_SHUTTERSPEED2_2s                0x0030
#define ABC_SHUTTERSPEED2_1s5	              0x0034
#define ABC_SHUTTERSPEED2_1s	               0x0038
#define ABC_SHUTTERSPEED2_0s7	              0x003C
#define ABC_SHUTTERSPEED2_0s5	              0x0040
#define ABC_SHUTTERSPEED2_0s3	              0x0044
#define ABC_SHUTTERSPEED2_1_4 		            0x0048
#define ABC_SHUTTERSPEED2_1_6 		            0x004c
#define ABC_SHUTTERSPEED2_1_8 		            0x0050
#define ABC_SHUTTERSPEED2_1_10		            0x0054
#define ABC_SHUTTERSPEED2_1_15		            0x0058
#define ABC_SHUTTERSPEED2_1_20		            0x005c
#define ABC_SHUTTERSPEED2_1_30		            0x0060
#define ABC_SHUTTERSPEED2_1_45		            0x0064
#define ABC_SHUTTERSPEED2_1_60		            0x0068
#define ABC_SHUTTERSPEED2_1_90		            0x006c
#define ABC_SHUTTERSPEED2_1_125	            0x0070
#define ABC_SHUTTERSPEED2_1_180	            0x0074
#define ABC_SHUTTERSPEED2_1_250	            0x0078
#define ABC_SHUTTERSPEED2_1_350	            0x007c
#define ABC_SHUTTERSPEED2_1_500	            0x0080
#define ABC_SHUTTERSPEED2_1_750	            0x0084
#define ABC_SHUTTERSPEED2_1_1000	           0x0088
#define ABC_SHUTTERSPEED2_1_1500	           0x008c
#define ABC_SHUTTERSPEED2_1_2000	           0x0090
#define ABC_SHUTTERSPEED2_1_3000	           0x0094
#define ABC_SHUTTERSPEED2_1_4000	           0x0098
#define ABC_SHUTTERSPEED2_1_6000	           0x009c
#define ABC_SHUTTERSPEED2_1_8000	           0x00a0
#define ABC_SHUTTERSPEED2_1_12000	          0x00a4
#define ABC_SHUTTERSPEED2_1_16000	          0x00a8

// ---------------------------------------------------------------------------
// 2: ABC_IMGSETTING_APERTURE (Camera set to 1/3-stop - C.Fn-6 = 0)
// ---------------------------------------------------------------------------
#define ABC_APERTURE3_1_0		                 0x0008
#define ABC_APERTURE3_1_1		                 0x000b
#define ABC_APERTURE3_1_2		                 0x000d
#define ABC_APERTURE3_1_4		                 0x0010
#define ABC_APERTURE3_1_6		                 0x0013
#define ABC_APERTURE3_1_8		                 0x0015
#define ABC_APERTURE3_2_0		                 0x0018
#define ABC_APERTURE3_2_2		                 0x001b
#define ABC_APERTURE3_2_5		                 0x001d
#define ABC_APERTURE3_2_8		                 0x0020
#define ABC_APERTURE3_3_2		                 0x0023
#define ABC_APERTURE3_3_5		                 0x0025
#define ABC_APERTURE3_4_0		                 0x0028
#define ABC_APERTURE3_4_5		                 0x002b
#define ABC_APERTURE3_5_0		                 0x002d
#define ABC_APERTURE3_5_6		                 0x0030
#define ABC_APERTURE3_6_3		                 0x0033
#define ABC_APERTURE3_7_1		                 0x0035
#define ABC_APERTURE3_8_0		                 0x0038
#define ABC_APERTURE3_9_0		                 0x003b
#define ABC_APERTURE3_10_0	                 0x003d
#define ABC_APERTURE3_11_0	                 0x0040
#define ABC_APERTURE3_13_0	                 0x0043
#define ABC_APERTURE3_14_0	                 0x0045
#define ABC_APERTURE3_16_0	                 0x0048
#define ABC_APERTURE3_18_0	                 0x004b
#define ABC_APERTURE3_20_0	                 0x004d
#define ABC_APERTURE3_22_0	                 0x0050
#define ABC_APERTURE3_25_0	                 0x0053
#define ABC_APERTURE3_29_0	                 0x0055
#define ABC_APERTURE3_32_0	                 0x0058
#define ABC_APERTURE3_36_0	                 0x005b
#define ABC_APERTURE3_40_0	                 0x005d
#define ABC_APERTURE3_45_0	                 0x0060
#define ABC_APERTURE3_51_0	                 0x0063
#define ABC_APERTURE3_57_0	                 0x0065
#define ABC_APERTURE3_64_0	                 0x0068
#define ABC_APERTURE3_72_0	                 0x006b
#define ABC_APERTURE3_81_0	                 0x006d
#define ABC_APERTURE3_91_0	                 0x0070

// ---------------------------------------------------------------------------
// 2: ABC_IMGSETTING_APERTURE (Camera set to 1/2-stop - C.Fn-6 = 1)
// ---------------------------------------------------------------------------
#define ABC_APERTURE2_1_0		                 0x0008
#define ABC_APERTURE2_1_2		                 0x000c
#define ABC_APERTURE2_1_4		                 0x0010
#define ABC_APERTURE2_1_8		                 0x0014
#define ABC_APERTURE2_2_0		                 0x0018
#define ABC_APERTURE2_2_5		                 0x001c
#define ABC_APERTURE2_2_8		                 0x0020
#define ABC_APERTURE2_3_5		                 0x0024
#define ABC_APERTURE2_4_0		                 0x0028
#define ABC_APERTURE2_4_5		                 0x002c
#define ABC_APERTURE2_5_6		                 0x0030
#define ABC_APERTURE2_6_7		                 0x0034
#define ABC_APERTURE2_8_0		                 0x0038
#define ABC_APERTURE2_9_5		                 0x003c
#define ABC_APERTURE2_11_0	                 0x0040
#define ABC_APERTURE2_13_0	                 0x0044
#define ABC_APERTURE2_16_0	                 0x0048
#define ABC_APERTURE2_19_0	                 0x004c
#define ABC_APERTURE2_22_0	                 0x0050
#define ABC_APERTURE2_27_0	                 0x0054
#define ABC_APERTURE2_32_0	                 0x0058
#define ABC_APERTURE2_38_0	                 0x005c
#define ABC_APERTURE2_45_0	                 0x0060
#define ABC_APERTURE2_54_0	                 0x0064
#define ABC_APERTURE2_64_0	                 0x0068
#define ABC_APERTURE2_76_0	                 0x006c
#define ABC_APERTURE2_91_0	                 0x0070

// ---------------------------------------------------------------------------
// 3: ABC_IMGSETTING_ISO
// ---------------------------------------------------------------------------
#define ABC_ISO_100		                       0x0048
#define ABC_ISO_200		                       0x0050
#define ABC_ISO_400		                       0x0058
#define ABC_ISO_800		                       0x0060
#define ABC_ISO_1600		                      0x0068

// ---------------------------------------------------------------------------
// 4: ABC_IMGSETTING_EXP_COMPENSATION
// 9: ABC_IMGSETTING_FLASH_EXP_COMP
// ---------------------------------------------------------------------------
#define ABC_COMP_300_PLUS                     0x18
#define ABC_COMP_266_PLUS                     0x15
#define ABC_COMP_250_PLUS                     0x14
#define ABC_COMP_233_PLUS                     0x13
#define ABC_COMP_200_PLUS                     0x10
#define ABC_COMP_166_PLUS                     0x0d
#define ABC_COMP_150_PLUS                     0x0c
#define ABC_COMP_133_PLUS                     0x0b
#define ABC_COMP_100_PLUS                     0x08
#define ABC_COMP_066_PLUS                     0x05
#define ABC_COMP_050_PLUS                     0x04
#define ABC_COMP_033_PLUS                     0x03
#define ABC_COMP_000_PLUS                     0x00
#define ABC_COMP_033_MINUS                    0xfd
#define ABC_COMP_050_MINUS                    0xfc
#define ABC_COMP_066_MINUS                    0xfb
#define ABC_COMP_100_MINUS                    0xf8
#define ABC_COMP_133_MINUS                    0xf5
#define ABC_COMP_150_MINUS                    0xf4
#define ABC_COMP_166_MINUS                    0xf3
#define ABC_COMP_200_MINUS                    0xf0
#define ABC_COMP_233_MINUS                    0xed
#define ABC_COMP_250_MINUS                    0xec
#define ABC_COMP_266_MINUS                    0xeb
#define ABC_COMP_300_MINUS                    0xe8

// ---------------------------------------------------------------------------
// 5: ABC_IMGSETTING_METERING
// ---------------------------------------------------------------------------
#define ABC_METERING_SPOT                   0x0001
#define ABC_METERING_EVALUATIVE             0x0003
#define ABC_METERING_PARTIAL                0x0004
#define ABC_METERING_CENTER_WEIGHTED        0x0005

// ---------------------------------------------------------------------------
// 6: ABC_IMGSETTING_AUTOFOCUS
// ---------------------------------------------------------------------------
#define ABC_AUTOFOCUS_ONE_SHOT              0x0000
#define ABC_AUTOFOCUS_AI_FOCUS              0x0002
#define ABC_AUTOFOCUS_AI_SERVO              0x0001
#define ABC_AUTOFOCUS_MANUAL_FOCUS          0x0003

// ---------------------------------------------------------------------------
// 7: ABC_IMGSETTING_WHITE_BALANCE
// ---------------------------------------------------------------------------
#define ABC_WB_AUTO				                     0x0000
#define ABC_WB_DAY_LIGHT			                 0x0001
#define ABC_WB_CLOUDY				                   0x0002
#define ABC_WB_TUNGSTEN			                  0x0003
#define ABC_WB_FLUORESCENT		                0x0004
#define ABC_WB_FLASH				                    0x0005
#define ABC_WB_CUSTOM				                   0x0006
#define ABC_WB_SHADE  			                   0x0008
#define ABC_WB_K      			                   0x0009      // 5D Only

// ---------------------------------------------------------------------------
// 8: ABC_IMGSETTING_PICTURE_QUALITY
// ---------------------------------------------------------------------------
#define ABC_PICTUREQUALITY_L_FINE       0x00010320      // L Fine
#define ABC_PICTUREQUALITY_L_NORMAL     0x00010220      // L Normal
#define ABC_PICTUREQUALITY_M_FINE       0x01010320      // M Fine
#define ABC_PICTUREQUALITY_M_NORMAL     0x01010220      // M Normal
#define ABC_PICTUREQUALITY_S_FINE       0x02010320      // S Fine
#define ABC_PICTUREQUALITY_S_NORMAL     0x02010220      // S Normal
//#define ABC_PICTUREQUALITY_RAW_L        0x00123420      // RAW+L (compatibility)
#define ABC_PICTUREQUALITY_RAW_L_FINE   0x00123420      // RAW+fL
#define ABC_PICTUREQUALITY_RAW_L_NORMAL 0x00122420
#define ABC_PICTUREQUALITY_RAW_M_FINE   0x10123420
#define ABC_PICTUREQUALITY_RAW_M_NORMAL 0x10122420
#define ABC_PICTUREQUALITY_RAW_S_FINE   0x20123420
#define ABC_PICTUREQUALITY_RAW_S_NORMAL 0x20122420
#define ABC_PICTUREQUALITY_RAW          0x00020420      // RAW
#define ABC_PICTUREQUALITY_IS_RAW(a)    (((a)&0x00000F00)==0x00000400)

// ---------------------------------------------------------------------------
// 10: ABC_IMGSETTING_AUTO_POWER_OFF
// ---------------------------------------------------------------------------
#define ABC_POWEROFF_OFF                         0
#define ABC_POWEROFF_1m                          1
#define ABC_POWEROFF_2m                          2
#define ABC_POWEROFF_4m                          4
#define ABC_POWEROFF_8m                          8
#define ABC_POWEROFF_15m                        15
#define ABC_POWEROFF_30m                        30

// ---------------------------------------------------------------------------
// 11: ABC_IMGSETTING_DRIVE_MODE
// ---------------------------------------------------------------------------
#define ABC_DRIVEMODE_SINGLE                0x0000      // Single shooting
#define ABC_DRIVEMODE_CONTINUOUS            0x0001      // Continuous shooting
#define ABC_DRIVEMODE_SELF_TIMER            0x0100      // Self-timer/Remote control

// ---------------------------------------------------------------------------
// 12: ABC_IMGSETTING_AEB
// ---------------------------------------------------------------------------
#define ABC_AEB_NOT_ACTIVE                    0x00
#define ABC_AEB_ACTIVE                        0x01

// ---------------------------------------------------------------------------
/* Unused values. Use ABC_CF_xxx defined in ABCanon.h
// 350D
#define ABC_CF350D_SETBUTTON_FUNCT          1
#define ABC_CF350D_LONGEXP_NOISE_RED        2
#define ABC_CF350D_FLASH_SYNC               3
#define ABC_CF350D_SHUTTER_AE_LOCK_BTN      4
#define ABC_CF350D_AF_ASSIST_BEAM           5
#define ABC_CF350D_EXP_LEVEL_INCREMENT      6
#define ABC_CF350D_MIRROR_LOCKUP            7
#define ABC_CF350D_E_TTL_II                 8
#define ABC_CF350D_SHUTTER_CURTAIN          9

// 5D
#define ABC_CF5D_FOCUSING_SCREEN            0
#define ABC_CF5D_SETBUTTON_FUNCT            1
#define ABC_CF5D_LONGEXP_NOISE_RED          2
#define ABC_CF5D_FLASH_SYNC                 3
#define ABC_CF5D_SHUTTER_AE_LOCK_BTN        4
#define ABC_CF5D_AF_ASSIST_BEAM             5
#define ABC_CF5D_EXP_LEVEL_INCREMENT        6
#define ABC_CF5D_FLASH_FIRING               7
#define ABC_CF5D_ISO_EXPANSION              8
#define ABC_CF5D_AEB_SEQUENCE               9
#define ABC_CF5D_SUPERIMPOSED_DISPLAY      10
#define ABC_CF5D_MENU_BUTTON_DISPLAY       11
#define ABC_CF5D_MIRROR_LOCKUP             12
#define ABC_CF5D_AF_POINT_SELECTION        13
#define ABC_CF5D_E_TTL_II                  14
#define ABC_CF5D_SHUTTER_CURTAIN           15
#define ABC_CF5D_SAFETY_SHIFT              16
#define ABC_CF5D_AF_POINT_ACTIVATION       17
#define ABC_CF5D_RETURN_TO_SHOOT           18
#define ABC_CF5D_LENS_AF_STOP_BUTTON       19
#define ABC_CF5D_ADD_ORIGINAL_DATA         20
*/
