﻿Public Class CameraSelection

  Public SelectedIndex As Integer
  Private bValid() As Boolean
  Private RowIndexToIdx() As Integer

  Public Sub ShowSelection(ByVal CameraList() As ABCanon7.sCameraData)

    Me.DGV.Rows.Clear()

    Dim IconIdx As Integer
    Dim Text As String
    Dim SelIdx As Integer = -1

    ReDim bValid(CameraList.Count - 1)
    ReDim RowIndexToIdx(CameraList.Count - 1)

    For i As Integer = 0 To CameraList.Count - 1

      Select Case CameraList(i).Status
        Case ABCanon7.eCameraStatus.ABC_STS_OK
          IconIdx = 0
          Text = CameraList(i).CameraName & " (SN: " & CameraList(i).SerialNumber.ToString & ", FW: " & CameraList(i).VersionH & "." & CameraList(i).VersionM & "." & CameraList(i).VersionL & ")"
          bValid(i) = True
          If SelIdx = -1 Then
            SelIdx = i
          End If
        Case ABCanon7.eCameraStatus.ABC_STS_INUSE
          IconIdx = 1
          Text = "Camera in USE!"
          bValid(i) = False
        Case Else
          IconIdx = 1
          Dim E As Integer = CameraList(i).Status
          Text = "Error " & E & " (" & CameraList(i).Status.ToString & ")"
          bValid(i) = False
      End Select

      Dim R() As Object = {Me.IL.Images(IconIdx), Text}
      RowIndexToIdx(i) = CameraList(i).Idx

      Me.DGV.Rows.Add(R)

    Next

    If SelIdx <> -1 Then
      Me.DGV.CurrentCell = Me.DGV.Rows(0).Cells(0)
      Me.DGV.Rows(SelIdx).Selected = True
      SelectedIndex = RowIndexToIdx(SelIdx)
      Me.BtnOK.Enabled = True
    Else
      Me.BtnOK.Enabled = False
    End If

    Dim x As Integer = (Me.DGV.Rows(0).Height + 0) * Me.DGV.Rows.Count
    Me.DGV.Height = x

    Me.ShowDialog()

  End Sub
  Private Sub BtnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCancel.Click

    Me.Close()

  End Sub
  Private Sub BtnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOK.Click

    Me.Close()

  End Sub
  Private Sub DGV_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DGV.CellClick

    SelectedIndex = RowIndexToIdx(e.RowIndex)
    Me.BtnOK.Enabled = bValid(SelectedIndex)

  End Sub
  Private Sub DGV_CellDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DGV.CellDoubleClick

    If bValid(e.RowIndex) = True Then
      Me.DialogResult = DialogResult.OK
      SelectedIndex = RowIndexToIdx(e.RowIndex)
      Me.Close()
    End If

  End Sub
End Class