﻿Imports ABUtilities2.ABCanon7
Imports System.Threading
Public Class Main

 ' Quello che vorrei provare a fare è eliminare le chiamate ESPLICITE alle seguenti funzioni
 ' * EnableDisableChangeButtons(): Abilita/Disabilita i 4 bottoni (First/Left/Right/Last) in base a cosa c'è selezionato
 ' * UpdateShootingStatus():       Aggiorna l'indicazione di errore (da Camera.CameraError), visualizza ev. notifiche (gNotificationMsg), il fatto che si 
 '                                 possa scattare o meno (BULB, Timer...) e abilita/disabilita il bottone di scatto.
 ' * UpdateSaveTo():               Aggiorna la grafica di SaveTo in base alla variabile globale CurrentSaveTo già pre-impostata
 ' * UpdateParameters():           Aggiorna la grafica in base a Camera.AllImgSetting e .WritableSettings
 ' vedendo di sostituirle con chiamate "implicite" (tipo un evento che automaticamente chiama la funzione) senza che ci si debba
 ' ricordare di chiamarle tutte le volte
 ' Ho trasformato CurrentSaveTo in una proprietà che fa esattamente questo. Però... se finisco in BUSY, essendo una proprietà non la posso
 ' fare async/await (anche se quella interna, Camera.SaveTo lo potrebbe essere) per cui avrei di fatto fatto un passo avanti e uno indietro.
 ' Ma visto la nota sotto (CMQ...) va bene così. 
 ' Ho messo l'evento di "Error" in ABCamera7, per cui una parte di UpdateShootingStatus() la lego a quello e posso togliere quelli espliciti (TODO) 
 ' PERO'... aggiornerebbe anche il ShootingAllowed e quello non fa eventi.... NOIA! Però a naso lo posso fare su ABC_EVENT_SETTINGS_CHANGED (lo fa già)
 ' per cui magari funziona. Da provare.
 ' Fatto, la UpdateShootingStatus() è rimasta per:
 ' *) ABC_EVENT_SETTINGS_CHANGED
 ' *) UpdateAllButtonsStatus      <------- che però vorrei togliere
 ' *) ShowNotification
 ' *) TmrNotification_Tick
 ' *) Camera_Error
 '
 ' UpdateParameters(): chiamato da:
 ' *) form_Load()
 ' *) ABC_EVENT_SETTINGS_CHANGED
 ' *) Fine ABC_EVENT_BUSY
 ' *) iChangeParameters(ABC_IMGSETTING_PICTURE_QUALITY o uno qualunque, in 2 posti)
 ' Che quindi sostanzialmente è dove mi aspetto, TRANNE quella in iChangeParameters che poi voglio vedere... ma prima mi conviene verificare che la 
 ' iChangeParameters mi triggeri ABC_EVENT_SETTINGS_CHANGED    <---------- Da verificare <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 ' 
 ' EnableDisableChangeButtons(): chiamata da:
 ' *) UpdateParameters()
 ' *) UpdateAllButtonsStatus()
 ' *) ModifiableItems_Click()    che è sostanzialmente quando si cambia "oggetto"
 ' *) PBSaveTo_Click()           ragione simile al _Click sopra
 ' *) iChangeParameter()
 ' *) MIAllowBulbSelection()     Menù
 ' Riguardo la iChangeParameters() dovrebbe bastare legarla a ABC_EVENT_SETTINGS_CHANGED perché alla fine cambiano se cambia quello
 ' Per i _Click() mi conviene fare un "evento" quando si cambia l'oggetto selezionato (anche x ev. avere hot-keys)
 ' Stando all'interno della classe probab. non un evento ma una proprietà così "centralizzo" le impostazioni. La variabile credo ci sia già
 ' (SelectedControlIdx). E facendo quello evito di fare tutte le chiamate a Me.DisplayPanel.Invalidate()!!! e EnableDisableChangeButtons()
 ' Dopo aver fatto la proprietà SelectedControlIdx, la EnableDisableChangeButtons() mi rimane chiamata da:
 ' *) SelectedControlIdx
 ' *) UpdateParameters
 ' *) UpdateAllButtonsStatus
 ' *) iChangeParameter
 ' *) MIAllowBulbSelection.Click
 ' Alla fine, UpdateAllButtonsStatus() è quella che mi pare ancora un po' fuori luogo.
 ' Chi la chiama?
 ' form_load
 ' ABC_EVENT_BATTERY_STATUS_CHANGED
 ' ABC_EVENT_xxx_SAVED      
 ' ABC_EVENT_xxx_SAVE_FAILED    
 ' ABC_EVENT_AF_FAILED
 ' ABC_EVENT_CAMERA_DISCONNECTED
 ' ABC_EVENT_BUSY
 ' BtnShoot_Click



 ' Per gli errori della camera... lo faccio chiamando la UpdateShootingStatus() ma mi conviene fare un evento da Camera... <----------

 ' Partendo per la tangente, e volendo "giocare" con rendere la grafica più comoda quando sto "parlando" con la camera per le operazioni TaskAsync
 ' (quelle per cui l'operazione viene fatta in un Task implicito per non "caricare" la UI) potrebbe essere carino mettere un evento (magari Opt-in)
 ' nella DLL su Lock/Unlock che disabilita la grafica, in modo che anche se l'operazione ha await non si possa rientrare, il tutto in modo piuttosto
 ' automatico (dove il CanonLock che toglie il bit di busy mi fa un unlock)
 ' Oppure legarla internamente alla libreria al Mutex di lock, quando lo sto acquisendo
 ' NOPE: se arriva da un'altra thread, finisce un po' lo scopo. Però lo posso fare dalla ABCanon7, almeno x i metodi Async e TaskAsync
 ' CMQ... alla fine tirando le somme: non mi conviene ristrutturare totalmente il sw per gestire le operazioni asicnrone. Queste sono molto più utili
 ' quando si eseguono degli "script" rispetto a quando si usa un programma interattivo. Qui facciamo che ignoriamo l'operazione se fa busy e ce ne 
 ' freghiamo del tempo che serve a farla visto che si cambia una cosa sola alla volta (e quindi 20/30ms di operazione sono accettabili).
 ' Facciamo solo un po' di ordine mettendo degli "oggetti" per eliminare le chiamate esplicite sopra, e bon (più il resto)

 Private WithEvents Camera As ABCanon7
 Private EnabledControls() As Boolean

 Private ControlArray() As Control

 Public Const RegistrySectionBase As String = "ABCanon7"

 Private RegConfig As RegistryConfig
 Private SaveDataValid As Boolean

 ' Is any of ABCanon7.eShotParameters or
 Private Const cSELIDX_NONE = -99
 Private Const cSELIDX_SAVETO = -1
 Private gSelectedControlIdx As Integer = cSELIDX_NONE

 Private Enum eMySaveTo
  PCOnly = 0
  PCandCF = 1
 End Enum
 ' Since SaveTo cannot be read back we start from PCOnly and keep current value in a variable
 Private gCurrentSaveTo As eMySaveTo

 ' Long story short: Me.UseWaitCursor and me.Enabled suck, so, since we are doing
 ' the button animation ourselves, here we can use a global variable to ignore button clicks.
 ' This does not normally work because of button animations (and does not work at all for all the
 ' other controls)
 Private gIgnoreButtonClicks As Boolean

 ' Since we are using async/await to schedule the timer shooting, let's use a variable to
 ' to signal we are in timer-shooting. But since we have something else to handle, use the
 ' InTimerShooting property
 Private gInTimerShooting As Boolean

 Private gCancellationTS As New CancellationTokenSource

 Private gTimerAnimationPhase As Boolean

 Private gShutterOpen As Boolean
 Private gIsBusy As Boolean
 Private gCameraDisconnected As Boolean

 ' Text to be shown as notification on the error label for a few seconds when requested.
 Private gNotificationMsg As String = Nothing

 Private Sub Main_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

  ControlArray =
   {
    Me.PBModeDial, Me.LblShutterSpeed, Me.LblAperture, Me.LblISO, Nothing, Me.PBMetering, Nothing, Me.PBWhiteBalance,
    Me.PBPictureQuality, Nothing, Nothing, Me.PBDriveMode, Nothing, Me.LblColorTemp
   }

  AddHandler Me.BtnFirst.Click, AddressOf Button_Click
  AddHandler Me.BtnLeft.Click, AddressOf Button_Click
  AddHandler Me.BtnRight.Click, AddressOf Button_Click
  AddHandler Me.BtnLast.Click, AddressOf Button_Click

  Dim OpenMode As ABCanon7.eConnectMode
  Dim CameraParam As UInt32

  ' If the command line has a specific serial number, open that
  If Command.Length > 4 AndAlso Command.Substring(0, 4).ToLower = "/sn=" Then
   UInt32.TryParse(Command.Substring(4), CameraParam)

   Debug.Print("Serial Number: {0}", CameraParam)
   OpenMode = eConnectMode.BySerialNumber

  Else

   ' Open first camera or show camera selector
   Dim Cameras() As sCameraData = ABCanon7.GetConnectedCameras

   If IsNothing(Cameras) Then
    Me.Show()
    MsgBox("No supported cameras found!", vbExclamation)
    Me.Close()
    Exit Sub
   End If

   Debug.Print("Cameras:  {0}", Cameras.Length)

   If Cameras.Length = 1 Then
    ' Only one camera, select that
    OpenMode = eConnectMode.FirstAvailable
   Else
    ' Show Camera selection dialog
    CameraSelection.ShowSelection(Cameras)
    If CameraSelection.DialogResult <> DialogResult.OK Then
     Me.Close()
     Exit Sub
    Else
     OpenMode = eConnectMode.ByIndex
     CameraParam = CameraSelection.SelectedIndex
    End If
   End If

  End If

  Try
   Camera = New ABCanon7(OpenMode, CameraParam)
  Catch ex As Exception
   MsgBox("Camera not found!", vbExclamation)
   Me.Close()
   Exit Sub
  End Try
  Camera.Options = eOptions.HANDLE_THREAD_BUSY Or eOptions.PCT2 Or eOptions.BUSYPOLL

  Me.TSLOwner.Text = Camera.OwnerName

  LoadRegistryConfig()

  ' SaveTO starts to "PC"
  CurrentSaveTo = eMySaveTo.PCOnly

  UpdateBattery(Camera.BatteryStatus)
  UpdateParameters()

  UpdateAllButtonsStatus()

 End Sub
 Private Sub Main_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown

  Dim C As Control = Nothing

  Select Case e.KeyCode
   Case Keys.S
    C = Me.LblShutterSpeed
   Case Keys.A
    C = Me.LblAperture
   Case Keys.W
    C = Me.PBWhiteBalance
   Case Keys.C
    C = Me.LblColorTemp
   Case Keys.I
    C = Me.LblISO
   Case Keys.M
    C = Me.PBMetering
   Case Keys.Q
    C = Me.PBPictureQuality
   Case Keys.Add, Keys.Oemplus
    C = Me.BtnRight
   Case Keys.Subtract, Keys.OemMinus
    C = Me.BtnLeft
   Case Keys.Home
    C = Me.BtnFirst
   Case Keys.End
    C = Me.BtnLast
  End Select

  If C IsNot Nothing Then
   If TypeOf C Is Button Then
    Dim B As Button = C
    If B.Enabled Then
     B.PerformClick()
    End If
   Else
    ModifiableItems_Click(C, New System.EventArgs)
   End If
  End If

 End Sub
 Private Property SelectedControlIdx As Integer

  Get
   Return gSelectedControlIdx
  End Get
  Set(value As Integer)
   gSelectedControlIdx = value
   Me.DisplayPanel.Invalidate()
   EnableDisableChangeButtons()
  End Set

 End Property
 Private Property InTimerShooting As Boolean

  Get
   Return gInTimerShooting
  End Get
  Set(value As Boolean)
   gInTimerShooting = value
   Me.BtnShoot.ImageIndex = iShootButtonImageIndex(False)
   Me.TmrTimerAnimation.Enabled = value
  End Set

 End Property
 Private Sub TmrTimerAnimation_Tick(sender As Object, e As EventArgs) Handles TmrTimerAnimation.Tick

  gTimerAnimationPhase = Not gTimerAnimationPhase
  Me.BtnShoot.ImageIndex = iShootButtonImageIndex(False)

 End Sub
 Private Sub Camera_CameraEvent(Camera As ABCanon7, ByRef CameraEvent As ABCanon7.sEvent) Handles Camera.CameraEvent

  Dim CameraEventParameter() As Object = {CameraEvent}
  Invoke(New DlgInvokeCameraElement(AddressOf InvokeCameraElement), CameraEventParameter)
  CameraEvent = CameraEventParameter(0)

 End Sub
 Private Delegate Sub DlgInvokeCameraElement(ByRef CameraEvent As ABCanon7.sEvent)
 Private Sub InvokeCameraElement(ByRef CameraEvent As ABCanon7.sEvent)

  Debug.Print("Event.ID:     {0}", CameraEvent.EventID)
  Debug.Print("Event.Size:   {0}", CameraEvent.EventSize)
  Debug.Print("Event.Ptr:    {0}", CameraEvent.EventPtr)
  Debug.Print("InvokeRequired: {0}", Me.InvokeRequired)

  ' Normally the event has been handled, so return true
  ' The only exception is for the ABC_EVENT_xxx_READY events where True mean discard image!
  CameraEvent.Handled = True

  Select Case CameraEvent.EventID
   Case eEventID.ABC_EVENT_SETTINGS_CHANGED
    UpdateParameters()
    UpdateShootingStatus()
   Case eEventID.ABC_EVENT_BATTERY_STATUS_CHANGED
    UpdateBattery(CameraEvent.EventSize)
    If CameraEvent.EventSize <= ABCanon7.eBatteryStatus.ABC_BATTERY_LOW Then
     ' The battery is too low (or some kind of ERR xx happened within the camera).
     ' Notify and "disconnect" the camera
     ShowNotification("Low Battery!", False)
     gCameraDisconnected = True
     UpdateAllButtonsStatus()
    End If
   Case eEventID.ABC_EVENT_CR2_READY, eEventID.ABC_EVENT_JPG_READY
    ' We get this event BEFORE the DLL gets the access MUTEX to download the image.
    ' So we must now avoid to make calls to the DLL to avoid deadlocks until an 
    ' IMAGE_SAVED or IMAGE_SAVE_FAILED event arrives
    gIgnoreButtonClicks = True
    CameraEvent.Handled = True    ' 1.02
   Case eEventID.ABC_EVENT_CR2_SAVED, eEventID.ABC_EVENT_JPG_SAVED
    Dim FName As String = ABCanon7.GetTextForEvent(CameraEvent)
    ShowNotification("Image saved: " & System.IO.Path.GetFileName(FName), True)
    ' now show image. If DefaultImageViewerNoTimer, replace with DefaultImageViewer or DoNotShow
    ' depending on TimerShooting mode
    Dim VIM As RegistryConfig.eViewImageMode = RegConfig.ViewImageMode
    If VIM = RegistryConfig.eViewImageMode.DefaultImageViewerNoTimer Then
     If InTimerShooting = True Then
      VIM = RegistryConfig.eViewImageMode.DoNotShow
     Else
      VIM = RegistryConfig.eViewImageMode.DefaultImageViewer
     End If
    End If
    Select Case VIM
     Case RegistryConfig.eViewImageMode.DefaultImageViewer
      If RegConfig.JPEGOnly = False Or CameraEvent.EventID = eEventID.ABC_EVENT_JPG_SAVED Then  '  And InTimerShooting = False
       Try
        System.Diagnostics.Process.Start(FName)
       Catch
       End Try
      End If
    End Select
    gIgnoreButtonClicks = False
    gShutterOpen = False
    Me.TSLPB.Value = 0
    UpdateAllButtonsStatus()

   Case eEventID.ABC_EVENT_CR2_SAVE_FAILED, eEventID.ABC_EVENT_JPG_SAVE_FAILED
    ShowNotification("Image save failed", True)
    gIgnoreButtonClicks = False
    Me.TSLPB.Value = 0
    gShutterOpen = False
    UpdateAllButtonsStatus()

   Case eEventID.ABC_EVENT_AF_FAILED
    ShowNotification("AF failed", True)
    gIgnoreButtonClicks = False
    Me.TSLPB.Value = 0
    gShutterOpen = False
    UpdateAllButtonsStatus()

   Case eEventID.ABC_EVENT_DOWNLOADING
    If CameraEvent.EventSize <> 100 Then
     Me.TSLPB.Value = CameraEvent.EventSize + 1
    End If
    Me.TSLPB.Value = CameraEvent.EventSize

   Case eEventID.ABC_EVENT_CAMERA_DISCONNECTED
    ShowNotification("Camera disconnected", False)
    gCameraDisconnected = True
    gShutterOpen = False
    UpdateAllButtonsStatus()

   Case eEventID.ABC_EVENT_BUSY
    If CameraEvent.EventSize <> 0 Then
     gIsBusy = True
     UpdateShootingStatus()
    Else
     gIsBusy = False
     UpdateAllButtonsStatus()
     UpdateParameters()
    End If

  End Select

 End Sub
 ' ----------------------------------------------------------------
 Private Sub LoadRegistryConfig()

  ' Recall Config...
  Dim RegistrySection As String
  RegistrySection = RegistrySectionBase & "\" & Camera.SerialNumber.ToString
  RegConfig = New RegistryConfig(RegistrySection)

  ' And create directory just in case
  System.IO.Directory.CreateDirectory(RegConfig.DestinationFolder)

  ' Pass filename to library
  SaveDataValid = Camera.SetSaveFilename(RegConfig.DestinationFolder & "\" & RegConfig.ImagePrefix, RegConfig.NumberOfDigits)
  Dim ImageCounter As UInt32 = Camera.ImageCounter
  Debug.Print("FileName set: {0}, #{1}", SaveDataValid, ImageCounter)

  ' And set library to save to disk
  Camera.SetDownloadMode(eDownloadMode.SaveToFile)

  ' Get and set AllowBulb
  If Camera.CameraType = eCameraType.ABCTYPE_350D Then
   If RegConfig.AllowBULB Then
    Me.MIAllowBulbSelection.Checked = True
    Me.MIAllowBulbSelection_Click(Nothing, Nothing)
   End If
  Else
   Me.MIAllowBulbSelection.Checked = False
   Me.MIAllowBulbSelection.Enabled = False
  End If

  ' Timer
  Me.LblTimer.Visible = RegConfig.TimerEnabled
  Me.BtnShoot.ImageIndex = iShootButtonImageIndex(False)

 End Sub
 Private Property CurrentSaveTo As ABCanon7.eSaveTarget

  Get
   Return gCurrentSaveTo
  End Get
  Set(value As ABCanon7.eSaveTarget)
   gCurrentSaveTo = value
   Select Case gCurrentSaveTo
    Case eMySaveTo.PCOnly
     Me.PBSaveTo.Image = Me.ILSaveTo.Images(0)
     Camera.SaveTo(ABCanon7.eSaveTarget.SaveToPC)
    Case eMySaveTo.PCandCF
     ' As the original canon code, we have 2 icons: a normal icon (1) and a warning icon
     ' to be used if there is no space on the CF
     If Camera.CFFreeKbytes > 0 Then
      Me.PBSaveTo.Image = Me.ILSaveTo.Images(1)
     Else
      Me.PBSaveTo.Image = Me.ILSaveTo.Images(2)
     End If
     Camera.SaveTo(ABCanon7.eSaveTarget.SaveToBoth)
   End Select
  End Set

 End Property
 Private Sub DeselectIfNotEnabled(ByVal SP As eImgSetting)

  ' De-select current item if no longer enabled
  If EnabledControls(SP) = False And SelectedControlIdx = SP Then
   SelectedControlIdx = cSELIDX_NONE
  End If

 End Sub
 Private Sub UpdateParameters()

  If Camera.CameraError <> eErrors.ABC_RETVAL_OK Then
   Exit Sub
  End If

  Dim SP() As UInteger = Camera.AllImgSettings
  EnabledControls = Camera.WritableParams

  Dim Txt As String
  Dim Idx As Integer

  ' MODE DIAL
  ' ------------
  Dim ShutterSpeedVisible As Boolean = True
  Select Case SP(ABCanon7.eImgSetting.ABC_IMGSETTING_MODE_DIAL)
   Case eSPModeDial.ABC_DIALMODE_AUTO
    Idx = 0
   Case eSPModeDial.ABC_DIALMODE_PROGRAM
    Idx = 1
   Case eSPModeDial.ABC_DIALMODE_Tv
    Idx = 2
   Case eSPModeDial.ABC_DIALMODE_Av
    Idx = 3
   Case eSPModeDial.ABC_DIALMODE_MANUAL
    Idx = 4
   Case eSPModeDial.ABC_DIALMODE_A_DEP
    Idx = 5
   Case eSPModeDial.ABC_DIALMODE_PORTRAIT
    Idx = 6
   Case eSPModeDial.ABC_DIALMODE_LANDSCAPE
    Idx = 7
   Case eSPModeDial.ABC_DIALMODE_CLOSEUP
    Idx = 8
   Case eSPModeDial.ABC_DIALMODE_SPORTS
    Idx = 9
   Case eSPModeDial.ABC_DIALMODE_NIGHT_PORTRAIT
    Idx = 10
   Case eSPModeDial.ABC_DIALMODE_NO_FLASH
    Idx = 11
   Case eSPModeDial.ABC_DIALMODE_BULB
    Idx = 12
    ShutterSpeedVisible = False
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBModeDial.Image = Nothing
  Else
   Me.PBModeDial.Image = Me.ILModeDial.Images(Idx)
  End If

  ' WHITE BALANCE
  ' -------------
  Select Case SP(ABCanon7.eImgSetting.ABC_IMGSETTING_WHITE_BALANCE)
   Case eSPWhiteBalance.ABC_WB_AUTO
    Idx = 0
   Case eSPWhiteBalance.ABC_WB_DAY_LIGHT
    Idx = 1
   Case eSPWhiteBalance.ABC_WB_CLOUDY
    Idx = 2
   Case eSPWhiteBalance.ABC_WB_TUNGSTEN
    Idx = 3
   Case eSPWhiteBalance.ABC_WB_FLUORESCENT
    Idx = 4
   Case eSPWhiteBalance.ABC_WB_FLASH
    Idx = 5
   Case eSPWhiteBalance.ABC_WB_CUSTOM
    Idx = 6
   Case eSPWhiteBalance.ABC_WB_SHADE
    Idx = 7
   Case eSPWhiteBalance.ABC_WB_K
    Idx = 8
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBWhiteBalance.Image = Nothing
  Else
   If EnabledControls(ABCanon7.eImgSetting.ABC_IMGSETTING_WHITE_BALANCE) = False Then
    Idx += 9
   End If
   Me.PBWhiteBalance.Image = Me.ILWhiteBalance.Images(Idx)
  End If
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_WHITE_BALANCE)

  ' COLOR TEMPERATURE
  ' -------------
  ' In the 350D there is no color temperature, so Camera.AllImgSettings will return an error, but I
  ' use just the fact that ABC_WB_K cannot be selected
  If SP(ABCanon7.eImgSetting.ABC_IMGSETTING_WHITE_BALANCE) <> ABCanon7.eSPWhiteBalance.ABC_WB_K Then
   Me.LblColorTemp.Text = ""
  Else
   Me.LblColorTemp.Text = SP(ABCanon7.eImgSetting.ABC_IMGSETTING_COLOR_TEMPERATURE)
  End If
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_COLOR_TEMPERATURE)

  ' METERING
  ' ---------------
  Select Case SP(ABCanon7.eImgSetting.ABC_IMGSETTING_METERING)
   Case eSPMetering.ABC_METERING_EVALUATIVE
    Idx = 0
   Case eSPMetering.ABC_METERING_PARTIAL
    Idx = 1
   Case eSPMetering.ABC_METERING_CENTER_WEIGHTED
    Idx = 2
   Case eSPMetering.ABC_METERING_SPOT
    Idx = 3
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBMetering.Image = Nothing
  Else
   If EnabledControls(ABCanon7.eImgSetting.ABC_IMGSETTING_METERING) = False Then
    Idx += 4
   End If
   Me.PBMetering.Image = Me.ILMetering.Images(Idx)
  End If
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_METERING)

  ' PICTURE QUALITY
  ' ---------------
  Select Case SP(ABCanon7.eImgSetting.ABC_IMGSETTING_PICTURE_QUALITY)
   Case eSPPictureQuality.ABC_PICTUREQUALITY_L_FINE
    Idx = 0
   Case eSPPictureQuality.ABC_PICTUREQUALITY_L_NORMAL
    Idx = 1
   Case eSPPictureQuality.ABC_PICTUREQUALITY_M_FINE
    Idx = 2
   Case eSPPictureQuality.ABC_PICTUREQUALITY_M_NORMAL
    Idx = 3
   Case eSPPictureQuality.ABC_PICTUREQUALITY_S_FINE
    Idx = 4
   Case eSPPictureQuality.ABC_PICTUREQUALITY_S_NORMAL
    Idx = 5
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_L_FINE
    Idx = 6
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_L_NORMAL
    Idx = 7
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_M_FINE
    Idx = 8
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_M_NORMAL
    Idx = 9
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_S_FINE
    Idx = 10
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW_S_NORMAL
    Idx = 11
   Case eSPPictureQuality.ABC_PICTUREQUALITY_RAW
    Idx = 12
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBPictureQuality.Image = Nothing
  Else
   Me.PBPictureQuality.Image = Me.ILPictureQuality.Images(Idx)
  End If
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_PICTURE_QUALITY)

  ' SHUTTER SPEED
  ' ---------------
  If EnabledControls(ABCanon7.eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED) = True Then
   Txt = ABCanon7.ShotParamToText(eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED, SP(ABCanon7.eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED))
   If Txt.Substring(0, 2) = "1/" Then
    Txt = Txt.Substring(2)
   End If
  Else
   Txt = ""
  End If
  Me.LblShutterSpeed.Text = Txt
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED)

  ' APERTURE
  ' --------
  If EnabledControls(ABCanon7.eImgSetting.ABC_IMGSETTING_APERTURE) = True Then
   Txt = "F/" & ABCanon7.ShotParamToText(eImgSetting.ABC_IMGSETTING_APERTURE, SP(ABCanon7.eImgSetting.ABC_IMGSETTING_APERTURE))
  Else
   Txt = ""
  End If
  Me.LblAperture.Text = Txt
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_APERTURE)

  ' ISO
  ' -----
  If EnabledControls(ABCanon7.eImgSetting.ABC_IMGSETTING_ISO) = True Then
   Txt = ABCanon7.ShotParamToText(eImgSetting.ABC_IMGSETTING_ISO, SP(ABCanon7.eImgSetting.ABC_IMGSETTING_ISO))
  Else
   Txt = "Auto"
  End If
  Me.LblISO.Text = Txt
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_ISO)

  ' DRIVE MODE
  Select Case SP(ABCanon7.eImgSetting.ABC_IMGSETTING_DRIVE_MODE)
   Case eSPDriveMode.ABC_DRIVEMODE_SINGLE
    Idx = 0
   Case eSPDriveMode.ABC_DRIVEMODE_CONTINUOUS
    Idx = 1
   Case eSPDriveMode.ABC_DRIVEMODE_SELF_TIMER
    Idx = 2
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBDriveMode.Image = Nothing
  Else
   Me.PBDriveMode.Image = Me.ILDriveMode.Images(Idx)
  End If
  ' De-select if not enabled
  DeselectIfNotEnabled(eImgSetting.ABC_IMGSETTING_DRIVE_MODE)

  ' AVAILABLE SHOTS
  ' ---------------
  Dim AvS As Integer = Camera.RemainingShots
  If AvS > 999 Then
   AvS = 999
  End If
  Me.LblAvailableShot.Text = AvS.ToString

  ' Update change button status
  EnableDisableChangeButtons()

  Me.LblShutterSpeed.Visible = ShutterSpeedVisible
  Me.LblAperture.Visible = True
  Me.LblAvailableShot.Visible = True
  Me.LblISO.Visible = True
  Me.LblColorTemp.Visible = True

 End Sub
 Private Sub UpdateBattery(ByVal BattSts As eBatteryStatus)

  Dim Idx As Integer

  Select Case BattSts
   Case eBatteryStatus.ABC_BATTERY_NORMAL
    Idx = 0
   Case eBatteryStatus.ABC_BATTERY_WEAK, eBatteryStatus.ABC_BATTERY_LOW, eBatteryStatus.ABC_BATTERY_LB
    Idx = 1
   Case Else
    Idx = -1
  End Select
  If Idx = -1 Then
   Me.PBBattery.Image = Nothing
  Else
   Me.PBBattery.Image = Me.ILBattery.Images(Idx)
  End If

 End Sub
 Private Sub UpdateShootingStatus()

  Dim Txt = ""
  Static LastCameraError As eErrors

  Select Case Camera.CameraError
   Case eErrors.ABC_RETVAL_OK
    Txt = ""
   Case eErrors.ABC_RETVAL_BUSY
    Txt = ""
   Case Else
    Txt = "Camera error " & Camera.CameraError.ToString
  End Select
  If LastCameraError <> Camera.CameraError Then
   Me.DisplayPanel.Invalidate()
   LastCameraError = Camera.CameraError
  End If

  If Txt.Length = 0 And gIsBusy Then
   Txt = "Camera is BUSY!"
  End If

  If Txt.Length = 0 And SaveDataValid = False Then
   Txt = "Destionation folder/filename is not valid"
  End If

  If Txt.Length = 0 And Not gCameraDisconnected Then
   Dim DeniedReason As eShootingDeniedReason = Camera.IsShootAllowed
   Select Case DeniedReason
    Case eShootingDeniedReason.BULB
     Txt = "BULB Mode is set"
    Case eShootingDeniedReason.MIRROR_LOCK
     Txt = "Mirror Lock is enabled"
    Case eShootingDeniedReason.SELF_TIMER
     Txt = "Self-timer is active"
   End Select
  End If

  ' If there is a notification to be shown, show it!
  If Not IsNothing(gNotificationMsg) Then
   Me.PBLabel.Text = gNotificationMsg
   Me.PBWarning.Visible = True
   Me.PBLabel.Visible = True
  ElseIf Txt.Length > 0 Then
   ' An error has to be shown
   Me.PBLabel.Text = Txt
   Me.PBWarning.Visible = True
   Me.PBLabel.Visible = True
  Else
   ' Nothing
   Me.PBWarning.Visible = False
   Me.PBLabel.Visible = False
  End If

  ' In case of error we have to disable the shooting button
  If Txt.Length = 0 And Not gShutterOpen And Not gCameraDisconnected And Not gIsBusy Then
   Me.BtnShoot.Enabled = True
  Else
   Me.BtnShoot.Enabled = False
  End If

 End Sub
 Private Sub UpdateAllButtonsStatus()

  UpdateShootingStatus()
  Me.DisplayPanel.Invalidate()
  EnableDisableChangeButtons()

 End Sub
 Private Sub ShowNotification(Notification As String, ByVal StartTimer As Boolean)

  gNotificationMsg = Notification
  Me.TmrNotification.Enabled = StartTimer
  UpdateShootingStatus()

 End Sub
 Private Sub TmrNotification_Tick(sender As System.Object, e As System.EventArgs) Handles TmrNotification.Tick

  gNotificationMsg = Nothing
  UpdateShootingStatus()
  Me.TmrNotification.Enabled = False

 End Sub
 Private Sub DisplayPanel_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles DisplayPanel.Paint

  Dim SelCtrl As Control

  ' For ShotParameters control (SelectedControlIdx >= 0) we use ControlArray to find the control to highlight
  ' For specific controls (SelectedControlIdx < 0) we use a select case statement
  Dim lSelectedControlIdx As Integer = SelectedControlIdx
  ' In case we are shooting, fake nothing is selected
  If gShutterOpen Or gIsBusy Or (Not IsNothing(Camera) AndAlso (Camera.CameraError <> eErrors.ABC_RETVAL_OK)) Then
   lSelectedControlIdx = cSELIDX_NONE
  End If
  Select Case lSelectedControlIdx
   Case Is >= 0
    If EnabledControls(lSelectedControlIdx) = False Then
     SelCtrl = Nothing
    Else
     SelCtrl = ControlArray(lSelectedControlIdx)
    End If
   Case cSELIDX_SAVETO
    SelCtrl = Me.PBSaveTo
   Case Else
    SelCtrl = Nothing
  End Select

  If IsNothing(SelCtrl) Then
   Exit Sub
  End If

  Dim R As New Rectangle(SelCtrl.Location, SelCtrl.Size)

  R.Inflate(4, 4)
  e.Graphics.FillRectangle(New SolidBrush(Color.Black), R)

 End Sub
 Private Sub EnableDisableChangeButtons()

  Dim lSelectedControlIdx As Integer = SelectedControlIdx
  ' In case we are shooting or there is a camera error, fake nothing is selected
  ' so no button will be enabled
  If gShutterOpen = True Or Camera.CameraError <> eErrors.ABC_RETVAL_OK Or gCameraDisconnected Then
   lSelectedControlIdx = cSELIDX_NONE
  End If

  Select Case lSelectedControlIdx
   Case cSELIDX_NONE
    ' Everything disabled
    Me.BtnFirst.Enabled = False
    Me.BtnLeft.Enabled = False
    Me.BtnRight.Enabled = False
    Me.BtnLast.Enabled = False
   Case cSELIDX_SAVETO
    ' Enable only left and right based on current option
    ' (Left = PC only, Right = Both)
    Me.BtnFirst.Enabled = False
    Me.BtnLeft.Enabled = (CurrentSaveTo = eMySaveTo.PCandCF)
    Me.BtnRight.Enabled = (CurrentSaveTo = eMySaveTo.PCOnly)
    Me.BtnLast.Enabled = False
   Case eImgSetting.ABC_IMGSETTING_PICTURE_QUALITY
    ' Picture quality enables left & right only
    Me.BtnFirst.Enabled = False
    Me.BtnLeft.Enabled = True
    Me.BtnRight.Enabled = True
    Me.BtnLast.Enabled = False
   Case Else
    ' Enable all, sort of.
    ' We get the list of the available items, and if the current one is the first or the
    ' last we do not enable buttons to that direction
    Dim ValueList() As UInteger = Camera.ShotParamValueList(lSelectedControlIdx)
    If Not IsNothing(ValueList) Then
     Dim Param As UInteger = Camera.ImgSetting(lSelectedControlIdx)
     ' There is one catch for one setting: if BULB is not allowed but it is
     ' selected anyway (from the camera) the library can just do absolute changes
     ' ("first" and "last" in this case) while relative changes (left and right)
     ' will not work because they don't understand the current
     ' setting so don't know where to go.
     ' So, in this case, I'll enable "Right" anyway (since it's expected to be so) and I'handle
     ' "Right" as if it were "First"
     If lSelectedControlIdx = eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED And Param = eSPShutterSpeed3.ABC_SHUTTERSPEED3_BULB And
       Me.MIAllowBulbSelection.Checked = False Then
      Me.BtnFirst.Enabled = False
      Me.BtnLeft.Enabled = False
      Me.BtnRight.Enabled = True
      Me.BtnLast.Enabled = True
     Else
      ' First: disable First and Left
      If ValueList(0) = Param Then
       Me.BtnFirst.Enabled = False
       Me.BtnLeft.Enabled = False
      Else
       Me.BtnFirst.Enabled = True
       Me.BtnLeft.Enabled = True
      End If
      ' Last: Disable Right and Last
      If ValueList(ValueList.Length - 1) = Param Then
       Me.BtnRight.Enabled = False
       Me.BtnLast.Enabled = False
      Else
       Me.BtnRight.Enabled = True
       Me.BtnLast.Enabled = True
      End If
     End If
    Else
     ' No list, should not happen. Enable everything, just in case
     Me.BtnFirst.Enabled = True
     Me.BtnLeft.Enabled = True
     Me.BtnRight.Enabled = True
     Me.BtnLast.Enabled = True
    End If
  End Select

 End Sub
 Private Sub ModifiableItems_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PBModeDial.Click, LblShutterSpeed.Click,
                            LblAperture.Click, PBWhiteBalance.Click, LblISO.Click, PBMetering.Click, PBPictureQuality.Click, PBDriveMode.Click,
                            LblColorTemp.Click

  Dim ShotParameter As ABCanon7.eImgSetting = sender.tag

  If EnabledControls(ShotParameter) = True Then
   SelectedControlIdx = ShotParameter
  End If

 End Sub
 Private Sub PBSaveTo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PBSaveTo.Click

  SelectedControlIdx = cSELIDX_SAVETO

 End Sub
 Private Sub Button_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles BtnFirst.Paint, BtnLast.Paint,
                                                                  BtnLeft.Paint, BtnRight.Paint, BtnShoot.Paint

  Dim Path As New System.Drawing.Drawing2D.GraphicsPath()

  Dim STag() As String = CType(sender.tag, String).Split({","}, StringSplitOptions.RemoveEmptyEntries)
  Dim Sx As Integer = STag(0)
  Dim Px As Integer = (sender.width - Sx) / 2

  ' Debug.Print("{0} {1} {2}", Sx, Px, sender.Width)

  If STag.Count > 3 And CType(sender, Button).ImageIndex > 1 Then
   Dim Dx As Integer = STag(1)
   Dim Dy As Integer = STag(2)
   Dim R As Integer = STag(3)
   Dim Cx As Integer = Px + Sx / 2 + Dx / 2
   Dim Cy As Integer = Px + Sx / 2 + Dy / 2
   Path.FillMode = Drawing2D.FillMode.Winding
   Path.AddEllipse(Cx, Cy, R, R)
  End If

  Path.AddEllipse(Px, Px, Sx, Sx)

  sender.Region = New Region(Path)

 End Sub
 Private Function iShootButtonImageIndex(ByVal Pressed As Boolean) As Integer

  Dim Idx As Integer

  ' 0 - Normal w/o a timer
  ' 2 - Normal with a gray timer
  ' 4 - Normal with a red timer
  ' +1 (odd) version have the 'clicked' style

  If RegConfig.TimerEnabled = False Then
   Idx = 0
  ElseIf InTimerShooting Then
   If gTimerAnimationPhase Then
    Idx = 2
   Else
    Idx = 4
   End If
  Else
   Idx = 2
  End If

  If Pressed Then
   Idx += 1
  End If

  Return Idx

 End Function
 Private Sub BtnShoot_PreviewKeyDown(sender As Object, e As PreviewKeyDownEventArgs) Handles BtnShoot.PreviewKeyDown

  If e.KeyCode = 13 Or e.KeyCode = 32 And Not gIgnoreButtonClicks Then
   sender.ImageIndex = iShootButtonImageIndex(True)
  End If

 End Sub
 Private Sub BtnShoot_MouseDown(sender As Object, e As MouseEventArgs) Handles BtnShoot.MouseDown

  If Not gIgnoreButtonClicks Then
   sender.ImageIndex = iShootButtonImageIndex(True)
  End If

 End Sub
 Private Sub Button_PreviewKeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles BtnFirst.PreviewKeyDown,
                  BtnLeft.PreviewKeyDown, BtnRight.PreviewKeyDown, BtnLast.PreviewKeyDown

  If e.KeyCode = 13 Or e.KeyCode = 32 And Not gIgnoreButtonClicks Then
   sender.ImageIndex = 1
  End If

 End Sub
 Private Sub Button_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BtnFirst.MouseDown,
              BtnLeft.MouseDown, BtnRight.MouseDown, BtnLast.MouseDown

  If Not gIgnoreButtonClicks Then
   sender.ImageIndex = 1
  End If

 End Sub
 Private Sub Button_Click(ByVal sender As Object, ByVal e As System.EventArgs)

  ' Generic click handler to restore "unclicked" image
  sender.ImageIndex = 0

 End Sub
 Private Sub iChangeParameter(ByVal ChangeType As ABCanon7.eSetType, ByVal ChangeValue As Integer)

  ' ?? gIgnoreButtonClicks = True
  Me.UseWaitCursor = True
  Me.Cursor = Cursors.WaitCursor

  Select Case SelectedControlIdx
   Case cSELIDX_SAVETO
    ' Only Left & Right are enabled, so we get what to do from ChangeValue
    If ChangeValue = -1 Then   ' LEFT = PCOnly
     CurrentSaveTo = eMySaveTo.PCOnly
    Else
     CurrentSaveTo = eMySaveTo.PCandCF
    End If
    EnableDisableChangeButtons()
   Case cSELIDX_NONE
    ' Doh!
   Case eImgSetting.ABC_IMGSETTING_PICTURE_QUALITY
    ' Picture quality does a "loop" change, so we use PreviousValue and NextValue instead
    If ChangeValue = -1 Then
     Camera.SetImgSetting(SelectedControlIdx, eSetType.PreviousValue, 0)
    Else
     Camera.SetImgSetting(SelectedControlIdx, eSetType.NextValue, 0)
    End If
    UpdateParameters()
    EnableDisableChangeButtons()
   Case Else
    ' Translate Change+1 (Right) to (First) if we're changing the Shutter Speed while in BULB with
    ' BULB selection not enabled
    If SelectedControlIdx = eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED AndAlso
                 Me.MIAllowBulbSelection.Checked = False AndAlso
                 ChangeType = eSetType.Change AndAlso ChangeValue = 1 AndAlso
                 Camera.ImgSetting(eImgSetting.ABC_IMGSETTING_SHUTTER_SPEED) = eSPShutterSpeed3.ABC_SHUTTERSPEED3_BULB Then
     ChangeType = eSetType.First
     ChangeValue = 0
    End If

    Camera.SetImgSetting(SelectedControlIdx, ChangeType, ChangeValue)
    ' It shound't be necessary to explictly update the parameters since the camera is supposed to send
    ' a change notification.
    ' But: 1) Canon code does this and 2) my emulator does not send that notification... ;)
    UpdateParameters()
    EnableDisableChangeButtons()
  End Select

  Me.UseWaitCursor = False
  Me.Cursor = Cursors.Default

 End Sub
 Private Sub BtnBegin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnFirst.Click

  If Not gIgnoreButtonClicks Then
   iChangeParameter(ABCanon7.eSetType.First, 0)
  End If

 End Sub
 Private Sub BtnLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnLeft.Click

  If Not gIgnoreButtonClicks Then
   iChangeParameter(ABCanon7.eSetType.Change, -1)
  End If

 End Sub
 Private Sub BtnRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRight.Click

  If Not gIgnoreButtonClicks Then
   iChangeParameter(ABCanon7.eSetType.Change, 1)
  End If

 End Sub
 Private Sub BtnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnLast.Click

  If Not gIgnoreButtonClicks Then
   iChangeParameter(ABCanon7.eSetType.Last, 0)
  End If

 End Sub
 Private Sub DestinationFolderToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles DestinationFolderToolStripMenuItem.Click

  ' Copy data and open form
  Dim S2S As New SaveToSelection
  S2S.SaveToSelection_Load(Me, RegConfig)
  If S2S.DialogResult = Windows.Forms.DialogResult.OK Then
   LoadRegistryConfig()
  End If

 End Sub
 Private Sub MIAllowBulbSelection_Click(sender As System.Object, e As System.EventArgs) Handles MIAllowBulbSelection.Click

  If Me.MIAllowBulbSelection.Checked = True Then
   Camera.Options = Camera.Options Or eOptions.BULB_IN_LIST
   RegConfig.AllowBULB = True
  Else
   Camera.Options = Camera.Options And Not eOptions.BULB_IN_LIST
   RegConfig.AllowBULB = False
  End If
  RegConfig.Save()
  EnableDisableChangeButtons()

 End Sub
 Private Async Sub BtnShoot_Click(sender As Object, e As System.EventArgs) Handles BtnShoot.Click

  If RegConfig.TimerEnabled Then
   ' Timer shooting
   If InTimerShooting Then
    Try
     gCancellationTS.Cancel()
    Catch
    End Try
    Exit Sub
   End If

   InTimerShooting = True

   Dim LoopStep As Integer
   Dim LoopLimit As Integer
   Dim ImgCount As Integer = 1
   If RegConfig.TimerCount = 0 Then
    LoopStep = 0
    LoopLimit = 1
   Else
    LoopStep = 1
    LoopLimit = RegConfig.TimerCount - 1
   End If
   Debug.Print("TimerShooting: Limit {0}, Step {1}", LoopLimit, LoopStep)

   If RegConfig.TimerDelay <> 0 Then
    Debug.Print("TimerShooting: Starting Delay... ({0}s)", RegConfig.TimerDelay)
    ShowNotification("Starting delay...", False)
    Try
     Await Task.Delay(RegConfig.TimerDelay * 1000, gCancellationTS.Token)
    Catch ex As TaskCanceledException
     ' So the whole for loop is skipped
     LoopLimit = -1
    End Try
   End If

   For i As Integer = 0 To LoopLimit Step LoopStep
    Debug.Print("TimerShooting: Image #{0}", i + LoopStep)
    ShowNotification(String.Format("Shooting image #{0}", ImgCount), True)
    If gCancellationTS.IsCancellationRequested Then
     Debug.Print("TimerShooting: Cancelled")
     Exit For
    End If

    If gCancellationTS.IsCancellationRequested Then
     Debug.Print("TimerShooting: Cancelled")
     Exit For
    End If

    ' To make the interval correct and also to avoid requesting a new shoot when the 
    ' shutter is still open, we start the interval delay and then await the shoot,
    ' finally awaiting on the interval delay
    Dim IntervalTask As Task = Nothing
    If i < LoopLimit Then
     Debug.Print("TimerShooting: TimerInterval start ({0}s)", RegConfig.TimerInterval)
     IntervalTask = Task.Delay(RegConfig.TimerInterval * 1000, gCancellationTS.Token)
    End If
    Debug.Print("TimerShooting: Shooting...")
    Dim rv As eErrors = Await Camera.ShootAsyc()
    Debug.Print("TimerShooting: ShootAsyc() = {0}", rv)
    If rv = eErrors.ABC_RETVAL_OK Then
     ImgCount += 1
    End If
    ' Non ho idea di cosa farmi dell'rv, ora... poi vediamo
    ' In ogni caso possiamo evitare l'ultimo 
    If i < LoopLimit Then
     Try
      Await IntervalTask
     Catch ex As TaskCanceledException
     End Try
    End If
    Debug.Print("TimerShooting: Interval Done")

   Next
   Debug.Print("TimerShooting: Done ---------------")
   If gCancellationTS.IsCancellationRequested Then
    ShowNotification("Timer shooting cancelled!", True)
   Else
    ShowNotification("Timer shooting done!", True)
   End If

   gCancellationTS = New CancellationTokenSource
   InTimerShooting = False

  Else
   ' NOT Timer shooting, standard shoot
   If Not gIgnoreButtonClicks Then
    Camera.Shoot()
    If Camera.CameraError = eErrors.ABC_RETVAL_OK Then
     gIgnoreButtonClicks = True
     gShutterOpen = True
    End If
    UpdateAllButtonsStatus()
   End If
  End If

  Me.BtnShoot.ImageIndex = iShootButtonImageIndex(False)

 End Sub
 Private Sub AboutToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles AboutToolStripMenuItem.Click

  About.ShowAbout(Me, Camera)

 End Sub
 Private Sub Camera_Error(Camera As ABCanon7) Handles Camera.Error

  If Me.InvokeRequired Then
   Me.Invoke(Sub()
              Camera_Error(Camera)
             End Sub)
   Exit Sub
  End If

  UpdateShootingStatus()

 End Sub
 Private Sub BtnTimerSettings_Click(sender As Object, e As EventArgs) Handles BtnTimerSettings.Click

  Dim OldTimerEnabled As Boolean = RegConfig.TimerEnabled
  If TimerSettings.ShowSettingsDialog(Me, RegConfig.TimerDelay, RegConfig.TimerInterval,
                                      RegConfig.TimerCount, RegConfig.TimerEnabled) = Windows.Forms.DialogResult.OK Then
   RegConfig.Save()
   Me.BtnShoot.ImageIndex = iShootButtonImageIndex(False)
   Me.LblTimer.Visible = RegConfig.TimerEnabled
   If OldTimerEnabled = True And RegConfig.TimerEnabled = False And InTimerShooting = True Then
    Try
     gCancellationTS.Cancel()
    Catch ex As Exception
    End Try
   End If

  End If

 End Sub

End Class
