﻿Public Class RegistryConfig

 ' Parameter saved to registry
 Public DestinationFolder As String
 Public ImagePrefix As String
 Public NumberOfDigits As Integer

 Public Enum eViewImageMode
  DoNotShow = 0
  DefaultImageViewer = 1
  DefaultImageViewerNoTimer = 1
 End Enum
 Public ViewImageMode As eViewImageMode

 Public JPEGOnly As Boolean
 Public AllowBULB As Boolean

 Public TimerDelay As Integer
 Public TimerInterval As Integer
 Public TimerCount As Integer
 Public TimerEnabled As Boolean

 ' -----------------------------
 Private gRegistrySection As String

 Public Sub New(RegistrySection As String)

  gRegistrySection = RegistrySection

  ' Load config
  Dim DefaultDestinationFolder As String = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures) & "\ABCanon"
  DestinationFolder = GetSetting(Application.ProductName, RegistrySection, "DestinationFolder", DefaultDestinationFolder)
  If DestinationFolder.Substring(DestinationFolder.Length - 1, 1) = "\" Then
   DestinationFolder = DestinationFolder.Substring(0, DestinationFolder.Length - 1)
  End If
  ImagePrefix = GetSetting(Application.ProductName, RegistrySection, "ImagePrefix", "IMG_")
  NumberOfDigits = GetSetting(Application.ProductName, RegistrySection, "NumberOfDigits", 4)
  ViewImageMode = GetSetting(Application.ProductName, RegistrySection, "ViewImageMode", eViewImageMode.DefaultImageViewer)
  JPEGOnly = GetSetting(Application.ProductName, RegistrySection, "JPEGOnly", True)
  AllowBULB = GetSetting(Application.ProductName, RegistrySection, "AllowBULB", False)

  TimerDelay = GetSetting(Application.ProductName, RegistrySection, "TimerDelay", 0)
  TimerInterval = GetSetting(Application.ProductName, RegistrySection, "TimerInterval", 10)
  TimerCount = GetSetting(Application.ProductName, RegistrySection, "TimerCount", 0)
  TimerEnabled = GetSetting(Application.ProductName, RegistrySection, "TimerEnabled", False)

 End Sub
 Public Sub Save()

  SaveSetting(Application.ProductName, gRegistrySection, "DestinationFolder", DestinationFolder)
  SaveSetting(Application.ProductName, gRegistrySection, "ImagePrefix", ImagePrefix)
  SaveSetting(Application.ProductName, gRegistrySection, "NumberOfDigits", NumberOfDigits)
  SaveSetting(Application.ProductName, gRegistrySection, "ViewImageMode", ViewImageMode)
  SaveSetting(Application.ProductName, gRegistrySection, "JPEGOnly", JPEGOnly)
  SaveSetting(Application.ProductName, gRegistrySection, "AllowBULB", AllowBULB)
  SaveSetting(Application.ProductName, gRegistrySection, "TimerDelay", TimerDelay)
  SaveSetting(Application.ProductName, gRegistrySection, "TimerInterval", TimerInterval)
  SaveSetting(Application.ProductName, gRegistrySection, "TimerCount", TimerCount)
  SaveSetting(Application.ProductName, gRegistrySection, "TimerEnabled", TimerEnabled)

 End Sub

End Class
