﻿Public Class SaveToSelection

 Private ViewOption As RegistryConfig.eViewImageMode
 Private gRegConfig As RegistryConfig

 Public Sub SaveToSelection_Load(Parent As Form, ByRef RegConfig As RegistryConfig)

  gRegConfig = RegConfig
  Me.TxtDestinationFolder.Text = RegConfig.DestinationFolder
  Me.TxtFilePrefix.Text = RegConfig.ImagePrefix
  Try
   Me.NUDDigits.Value = RegConfig.NumberOfDigits
  Catch ex As Exception
  End Try

  Dim Rb As RadioButton = Me.GB2.Controls("RBView" & RegConfig.ViewImageMode)
  If IsNothing(Rb) Then
   Me.RBView0.Checked = True
  Else
   Rb.Checked = True
  End If

  Select Case RegConfig.ViewImageMode
   Case RegistryConfig.eViewImageMode.DefaultImageViewer
    Me.CkDefaultViewJPGOnly.Checked = RegConfig.JPEGOnly
  End Select

  Me.ShowDialog(Parent)

 End Sub
 Private Sub BtnBrowse_Click(sender As System.Object, e As System.EventArgs) Handles BtnBrowse.Click

  Dim dialog = New FolderBrowserDialog()
  dialog.SelectedPath = Me.TxtDestinationFolder.Text
  If DialogResult.OK = dialog.ShowDialog() Then
   Me.TxtDestinationFolder.Text = dialog.SelectedPath
  End If

 End Sub
 Private Sub BtnCancel_Click(sender As System.Object, e As System.EventArgs) Handles BtnCancel.Click

  Me.DialogResult = Windows.Forms.DialogResult.Cancel
  Me.Close()

 End Sub
 Private Sub BtnOK_Click(sender As Object, e As System.EventArgs) Handles BtnOK.Click

  Me.DialogResult = Windows.Forms.DialogResult.OK

  gRegConfig.DestinationFolder = Me.TxtDestinationFolder.Text
  gRegConfig.ImagePrefix = Me.TxtFilePrefix.Text
  gRegConfig.NumberOfDigits = Me.NUDDigits.Value
  gRegConfig.ViewImageMode = ViewOption
  gRegConfig.JPEGOnly = Me.CkDefaultViewJPGOnly.Checked
  gRegConfig.Save()

  Me.Close()

 End Sub
 Private Sub RBViewX_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RBView0.CheckedChanged,
   RBView1.CheckedChanged, RBView2.CheckedChanged

  If sender.checked = True Then
   If RBView0.Checked = True Then
    ViewOption = RegistryConfig.eViewImageMode.DoNotShow
   End If
   If RBView1.Checked = True Then
    ViewOption = RegistryConfig.eViewImageMode.DefaultImageViewer
   End If
   If RBView2.Checked = True Then
    ViewOption = RegistryConfig.eViewImageMode.DefaultImageViewerNoTimer
   End If

   If ViewOption <> RegistryConfig.eViewImageMode.DoNotShow Then
    Me.CkDefaultViewJPGOnly.Enabled = True
   Else
    Me.CkDefaultViewJPGOnly.Enabled = False
    Me.CkDefaultViewJPGOnly.Checked = False
   End If

   Debug.Print("View option: {0}", ViewOption)
  End If

 End Sub

End Class